<?php
/**
 * Created by PhpStorm.
 * User: Administrator
 * Date: 2019/9/6
 * Time: 14:45
 */

namespace kwy\login\service;


use kwy\login\exception\PasswordErrorException;
use kwy\login\model\Company;
use kwy\login\model\CompanyShopStaff;
use kwy\login\model\KwyStaff;
use kwy\login\model\Shop;
use kwy\login\model\ShopToken;
use Lcobucci\JWT\Builder;
use Lcobucci\JWT\Signer\Hmac\Sha256;
use think\facade\Config;

class StaffLogin
{
    public function loginByShopId($shop_id,$username,$password){
        $company_model = new Company();
        $company_id = $company_model->getIdByShopId($shop_id);
        $staff = KwyStaff::where('company_id','=',$company_id)->where('no|tel','=',$username)->find();
        if(!$staff){
            throw new \Exception("用户不存在");
        }
        if(strcmp($staff['password'],$password)){
            throw new PasswordErrorException("密码错误");
        }
        $shop_find = CompanyShopStaff::where('company_id','=',$company_id)->where('shop_id','=',$shop_id)->where('staff_id','=',$staff['id'])->find();
        if(!$shop_find){
            throw new \Exception("没有权限");
        }
        $company_data = Company::where('id','=',$company_id)->find();
        if(!$company_data){
            throw new \Exception("企业数据缺失");
        }
        $company = [
            'id' => $company_data['id'],
            'name' => $company_data['name'],
            'short_name' => $company_data['short_name'],
            'shop_id' => $company_data['shop_id'],
            'kwy_industry_id' => $company_data['kwy_industry_id'],
        ];
        $shop_data = Shop::where('id','=',$shop_id)->find();
        if(!$shop_data){
            throw new \Exception("店铺数据缺失");
        }
        if($shop_data['status'] == '0'){
            throw new \Exception("店铺被禁用");
        }
        $shop = [
            'id' => $shop_data['id'],
            'name' => $shop_data['company_name'],
            'logo' => $shop_data['shoplogo_url'],
            'industry_id' => $shop_data['industry_id'],
        ];
        $user = [
            'id' => $staff['id'],
            'name' => $staff['name'],
            'tel' => $staff['tel'],
            'no' => $staff['no'],
            'role_id' => $staff['company_role_id'],
            'is_company_staff' => true,
        ];

        #jwt设置
        $signer = new Sha256();
        $token = (new Builder())->setIssuer('kwy_user_token')
            ->setIssuedAt(time())
            ->set('user',json_encode($user))
            ->set('company',json_encode($company))
            ->set('shop',json_encode($shop))
            ->set('time_key',time())
            ->sign($signer,Config::get('jwt.kwy_login','hgfhfwetsfdsdklmd124fdsfmk35'))
            ->getToken();
        $token_string = $token->__toString();
        #存入表，方便切换店铺
        $shop_token_find = ShopToken::where('shop_id','=',$shop_id)->where('staff_id','=',$staff['id'])->find();
        if($shop_token_find){
            model(ShopToken::class)->where('shop_id','=',$shop['id'])->where('staff_id','=',$staff['id'])->update(['token'=>$token_string]);
        }else{
            model(ShopToken::class)->insert(['shop_id'=>$shop['id'],'staff_id'=>$staff['id'],'token'=>$token_string]);
        }
        return $token_string;
    }

    public function loginByCompanyId($company_id,$username,$password){
        $staff = KwyStaff::where('company_id','=',$company_id)->where('no|tel','=',$username)->find();
        if(!$staff){
            throw new \Exception("用户不存在");
        }
        if(strcmp($staff['password'],$password)){
            throw new PasswordErrorException("密码错误");
        }
        $company_data = Company::where('id','=',$company_id)->find();
        if(!$company_data){
            throw new \Exception("企业数据缺失");
        }
        $company = [
            'id' => $company_data['id'],
            'name' => $company_data['name'],
            'short_name' => $company_data['short_name'],
            'shop_id' => $company_data['shop_id'],
            'kwy_industry_id' => $company_data['kwy_industry_id'],
        ];
        $shop_data = Shop::where('id','=',$company_data['shop_id'])->find();
        if(!$shop_data){
            throw new \Exception("店铺数据缺失");
        }
        if($shop_data['status'] == '0'){
            throw new \Exception("店铺被禁用");
        }
        $shop = [
            'id' => $shop_data['id'],
            'name' => $shop_data['company_name'],
            'logo' => $shop_data['shoplogo_url'],
            'industry_id' => $shop_data['industry_id'],
        ];
        $user = [
            'id' => $staff['id'],
            'name' => $staff['name'],
            'tel' => $staff['tel'],
            'no' => $staff['no'],
            'role_id' => $staff['company_role_id'],
            'is_company_staff' => true,
        ];
        #jwt设置
        $signer = new Sha256();
        $token = (new Builder())->setIssuer('kwy_user_token')
            ->setIssuedAt(time())
            ->set('user',json_encode($user))
            ->set('company',json_encode($company))
            ->set('shop',json_encode($shop))
            ->set('time_key',time())
            ->sign($signer,Config::get('jwt.kwy_login','hgfhfwetsfdsdklmd124fdsfmk35'))
            ->getToken();
        $token_string = $token->__toString();
        #存入表，方便切换店铺
        $shop_token_find = ShopToken::where('shop_id','=',$shop['id'])->where('staff_id','=',$staff['id'])->find();
        if($shop_token_find){
            model(ShopToken::class)->where('shop_id','=',$shop['id'])->where('staff_id','=',$staff['id'])->update(['token'=>$token_string]);
        }else{
            model(ShopToken::class)->insert(['shop_id'=>$shop['id'],'staff_id'=>$staff['id'],'token'=>$token_string]);
        }
        return $token_string;
    }

}